#!/bin/bash

#クォータ設定ユーザーリスト出力先
LIST=/root/mailquota/list.txt
DIRLIST=/root/mailquota/dirlist.txt
USERLIST=/root/mailquota/userlist.txt
#LOGDATE=`date "+%Y%m%d%H%M%S"`
#ログ出力先
LOG=/root/mailquota/log/quotawarn.log

#メール本文雛形※本文テキストはJISエンコーディングで作成
BODY=/root/mailquota/body.txt

#メール本文一時ファイル
BODY_TMP=/root/mailquota/bodytmp.txt

echo Check Start `date "+%Y%m%d %H:%M:%S"` >> $LOG

#クォータワーニング閾値
QUOTAWARN=`/bin/grep quotawarn /etc/imapd.conf |/bin/cut -d':' -f2|/bin/sed -e 's/ *//g'`
echo QuotaWarn is ${QUOTAWARN}% >> $LOG
#クォータ設定ユーザーの出力
#
#ls -1 /var/lib/imap/quota/*/* > $LIST

ls -1 /var/lib/imap/quota > $DIRLIST

while read FOLDER
do
    #メールボックス容量を取得
    #ls -1 /var/lib/imap/quota/$FOLDER >$USERLIST

    sts=0
    ls -1 /var/lib/imap/quota/$FOLDER >$USERLIST
    sts=$?
    if [ $sts -eq 0 ]
    then
        QUOTACOUNT=`ls -1 /var/lib/imap/quota/$FOLDER | wc -l`
        echo QuotaCount is ${FOLDER} = ${QUOTACOUNT} >>$LOG
    else
        echo Error: ls コマンドでエラーが発生した [${FOLDER}] >>$LOG
    fi

    while read USR
    do
        echo /var/lib/imap/quota/$FOLDER/$USR >>$LIST
    done < $USERLIST
    
done < $DIRLIST

#while read FOLDER
#do
#    #メールボックス容量を取得
#    ls -1 /var/lib/imap/quota/$FOLDER/* >>$LIST
#done < $DIRLIST

#FILEの読み込み
while read USER
do
    #メールボックス容量を取得
    INBOX=`head -1  $USER`
    #ユーザーに設定されたクォータの値を取得
    #QUOTA=`head -2 | tail -1 $USER`
    QUOTA=`head -2 $USER | tail -1`
    if [ $INBOX -gt 0 ]
    then
        #メールボックス使用率を計算(%)
        c=`echo "scale=2 ;  $INBOX / $QUOTA * 100 / 1024" | bc`
        #echo $c
        
        #クォータワーニング閾値を超えているか
        FLAG=`echo "$c > ${QUOTAWARN} " |bc`
        if [ $FLAG -eq 1 ]
        then
            cat $BODY >$BODY_TMP
            echo \ >> $BODY_TMP
            echo ${c}% used>> $BODY_TMP
            WARN_USER=`echo $USER | cut -d "." -f 2`
            #メールクォータワーニングユーザーの出力
            echo ${WARN_USER} is exceeding a quotawarn. ${c}% used >> $LOG
            
            #ワーニングメールの送信
            #echo Your Mailbox is ${c}% used. |mail -s "WARN" ${WARN_USER}
            cat $BODY_TMP |mail -s "=?ISO-2022-JP?B?GyRCJWEhPCVrJVwlQyUvJTlNRk5MJCwkYiQmJDkkMDBsR1UkRyQ5GyhC?=" ${WARN_USER}
        fi
   fi
done < $LIST

#クォータ設定ユーザーリストの削除
rm -f $LIST
rm -f $DIRLIST
rm -f $USERLIST
rm -f $BODY_TMP
echo Check End `date "+%Y%m%d %H:%M:%S"` >> $LOG
echo '/////////////////////////////////' >> $LOG